# ledctl

## Documentation

Each command sent through Serial is a single character followed by arguments in g-code style. For example: `F T200 R0 G0 B107`. All characters must be capitalized.

For any command's parameters, if it is not provided, the initial or last values will be used instead.

If a parameter is repeated, or two parameters that change the same values are used at the same time, the right-most occurrence takes precedence.

### `B` Breathe

Usage `B`

Changes into "Breathe" mode.

### `F` Fade

Usage: `F T<time> R<red> G<green> B<blue>`

Fades into a color specified by `R` `G` `B` in `T` milliseconds. Use `T0` for an instant change. Changes into "Set Color" mode.

Note that on a 328p, the maximum PWM resolution is 256 distinct values. If anything outside of that range is used, it will overflow.

### `T` Tickrate

Usage: `T R<rate> I<interval>`

Changed the ticks-per-second to `R`, or the tick interval by `I` milliseconds.